# **MatrixOne v0.1.0 Release Notes**


We are excited to announce the first release of MatrixOne 0.1.0 on 2021/10/24. Cheers!
***

## **Docker**
docker pull matrixorigin/matrixone:0.1.0

***

## **Features**

***

### **SQL**
Following SQL statements are supported in this release.

***

### **DDL**
* CREATE / DROP DATABASE
* CREATE / DROP TABLE
### **DML**
* INSERT
* LOAD DATA
* SELECT
    - WHERE
    - GROUP BY
    - ORDER BY
    - LIMIT, OFFSET
* SHOW
    - DATABASES
    - TABLES
* USE
### **Data Types**
* TINYINT / SMALLINT / INT / BIGINT, SIGNED / UNSIGNED
* FLOAT / DOUBLE
* CHAR / VARCHAR
### **Operators**
* &lt;, >=, <, <=, <>, !=, =
* BETWEEN … AND …, NOT BETWEEN … AND …
* AND, &&, OR, ||
* +, -, *, /, %, MOD, DIV, NEG
* CAST
### **Aggregation Functions**

* COUNT
* SUM
* AVG
* MAX
* MIN

## **Database Engine**
***
* MySQL dialect is supported.
* Build-in Append only columnar engine(AOE) has been supported as the first fusion database engine.
* Real-time analytical queries are supported.
* Vectorized query execution engine, based on MPP solution, is introduced.
* Part of the expression execution has been vectorized through SIMD instructions.
* Distributed AOE with strong consistency guaranteed by RAFT has been supported.
* The performance of replicated state machine has been greatly improved through the unique design of reusing RAFT log as well as Write-Ahead log without any redundancy.
## **Contributors**
***
This release includes 453 commits by 16 authors. Special thanks to the first author: 

Yan Wenze (@nnsgmsone)  
Chen Mingsong（@m-schen）  
Jin Hai (@JinHai-CN)  
Jiang xinmeng (@jiangxinmeng1)  
Li Yang (@lignay)  
Lin Junhong (@iamlinjunhong)  
lni (@lni)  
Long Ran (@aunjgr)  
Peng Zhen (@daviszhen)  
Qin Shuqi (@sukki37)  
Shen JiangWei(@LeftHandCold)  
Wei Ziran (@w-zr)  
Xiong Jingjuan (@anitajjx)  
Xu Peng (@XuPeng-SH)  
Yan Wenze(@nnsgmsone)  
Zilong Zhou (@zzl200012)  
Zhang Yingfeng (@yingfeng)